<template>
  <div>
    <OrderEvent
      v-for="(item, index) in events"
      :key="index"
      :data="item"
      @click.native="onSelected(item, $event)"
    />
    <EventModal
      ref="eventModal"
      :data-source="selectedEvent"
      :order="order"
      @updated="onSelected"
    />
    <EventModalDraftError
      ref="eventModalDraftError"
      :data-source="selectedErrorEvent"
    />
  </div>
</template>

<script>
import { mapGetters, mapMutations } from 'vuex'
import api from '@/api'
import cloneDeep from 'clone-deep'
import OrderEvent from '@/components/Order/orderItem/execution/events/OrderEvent'
import EventModal from '@/components/Order/orderItem/execution/events/modal'
import EventModalDraftError from '@/components/Order/orderItem/execution/events/modalDraftError'

export default {
  name: 'OrderEvents',
  components: {
    OrderEvent,
    EventModal,
    EventModalDraftError,
  },
  props: {
    events: {
      type: Array,
      default: () => []
    },
    order: {
      type: Object,
      default: () => {}
    },
    pointsInfo: {
      type: Object,
      default: () => {}
    }
  },
  data () {
    return {
      selectedEvent: {},
      selectedErrorEvent: {}
    }
  },
  computed: {
    ...mapGetters({
      selectedTrip: 'order/selectedTrip',
      subOrders: 'order/subOrders'
    }),
    isTrip () {
      return Boolean(this.selectedTrip)
    },
    isSuborder () {
      return Boolean(this.order.isSuborder)
    }
  },
  methods: {
    ...mapMutations({
      setReasonsList: 'order/setReasonsList',
    }),
    onErrorSelected (data) {
      this.selectedErrorEvent = this.processData(data, data.eventTypeCode);
      this.$refs.eventModalDraftError.open()
    },
    async onSelected (data, event) {
      const allowedCodes = ['ADD_POINT_EVENT', 'ARRIVING_DELAY', 'FORWARDING_EVENT', 'REMOVE_POINT_EVENT', 'TARIFF_CHANGED']

      if (data.eventTypeCode === 'DRAFT_ORDER_ERRORS') {
        this.onErrorSelected(data)
        return
      }
      if (!data.uuid || (event && event.target.closest('.toggle-button')) || (!this.isTrip && !allowedCodes.includes(data.eventTypeCode))) return

      try {
        const { currentEvent, eventHistory, reasons } = await api.orderProcess.getEventInfo({ uuid: data.uuid })

        const files = currentEvent.commonEventData && currentEvent.commonEventData.files || []
        const filesData = files.map(({ fileName, fileUuid }) => {
          return {
            uuid: fileUuid,
            file: {
              name: fileName
            },
            isUploaded: true
          }
        })
        currentEvent.commonEventData.fileUuids = files.map(file => file.fileUuid)

        let eventCode = currentEvent.commonEventData && currentEvent.commonEventData.eventTypeCode
        eventCode = eventCode ? eventCode.toLowerCase() : ''

        currentEvent.commonEventData.comment = currentEvent.commonEventData.comment || ''
        currentEvent.commonEventData.authorTitle = currentEvent.commonEventData.authorTitle || (currentEvent.commonEventData.creatorType === 'TRACKING' ? 'Трекинг' : 'Системное')

        if (reasons?.length) {
          this.setReasonsList({ code: eventCode.toUpperCase(), list: reasons })
        }

        if (currentEvent.specialParameters && !currentEvent.specialParameters.visitPointUuid) {
          delete currentEvent.specialParameters.visitPointUuid
        }

        this.selectedEvent = this.processData({
          filesData,
          eventHistory,
          uuid: data.uuid,
          eventData: currentEvent.commonEventData,
          specialParameters: currentEvent.specialParameters,
          point: this.isTrip && currentEvent.specialParameters?.visitPointUuid ? this.getPointInfo({ uuid: currentEvent.specialParameters.visitPointUuid }) : {},
          subOrders: this.subOrders.filter(item => item.status !== 'CANCELED'),
        }, eventCode)

        this.$refs.eventModal.open()
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: e?.message || 'Ошибка загрузки данных',
        })
      }
    },
    processData (data, eventCode) {
      let result = cloneDeep(data)

      const processMap = {}
      return eventCode && processMap[eventCode] ? processMap[eventCode]() : result
    },
    getPointInfo ({ uuid }) {
      let visitPoint = {}
      let visitPointDates = this.pointsInfo[uuid] || {}

      if (this.order.shipmentPoints) {
        this.order.shipmentPoints.forEach((point) => {
          if (point.shipmentPointUuid === uuid || point.visitPointUuid === uuid) {
            visitPoint = point
          }
        })
      }

      return {
        ...visitPoint,
        ...visitPointDates
      }
    }
  }
}
</script>
